#include "xparameters.h"
#include "xbasic_types.h"
#include "xio.h"
#include "terminal.h"
#include "pop.h"

#define BUF_SIZE 64
char buf[BUF_SIZE];
int addr;


int main()
{
  int i;
  char *k;
  init_video();
  k = read_pop();       //wait until we have a message
  write_to_sram(k);  //write message to sram
  i = read_from_sram(); //read message from sram
  write_to_video(); //send message to terminal
}

write_to_sram(char *string){
  int i,j = 0;
  int addr;
  do{
    addr = XPAR_SRAM_ETHERNET_0_BASEADDR + (i << 2);
    XIo_Out16(addr, *(string+j));
    i++;
  }  while(*(string+(j++)) != '\0');   //read until the end of the string (\0)
}

int read_from_sram(){
  int i=0; int j=0;
  do{ //read the first character regardless
    addr = XPAR_SRAM_ETHERNET_0_BASEADDR + (i << 2);
    buf[j] = XIo_In16(addr);
    i++;
  } while(buf[j++] != '\0');//read string, \0 will be in buf
  return i;
}


void write_to_video(){
  int j = 0;
  while(buf[j] != '\0'){
    char_to_video(buf[j]);
    j++;
  }
}

char *read_pop(){
  char *p;
  *p = '\0';
  while(*p == '\0')
    *p = pop();
  return p
}

