#include "pop.h"

int pop(){
  //start tcp stack
  popi_init();
  
  return 1;
}
  /*All commands are terminated by a
   *CRLF pair.*/

int state_machine(char *s){
  if(s[0] == '+'){ //we can tell pop accepts our commands 
    //by looking at the first character of the response
    switch(state){
    case 0: //connected, send user
      state++;
      return user;
    case 1: //user accepted, send pass
      state++;
      return pass;
    case 2: //pass accepted, get stat
      state++;
      return stat;
    case 3:
      //figure out what stat said
      if(*s+4 > '0'){ //there is at least one message, get it
	state++;
	return retr;
      } else{ //there are 0 messages, quit
	state = 6;
	return quit;
      }
    case 4: // got the message
      state++;
      strip_message(s); //remove smtp headers and others
      return dele;
    case 5: //message has been deleted
      state++;
      return quit;
    case 6: //connection closed 
      print("pop closed the connection successfully\r\n");
    default:
      ;;;
    }
  }
  else if(s[0] == '-')
    print("definite bad response, pop fails for unknown reason. check the server and pop.c\r\n");
  else
    print("unkown response from server. pop crashes hard\r\n");
  
}

char * strip_message(char *m){
  //ignore until blank line, which should appear as crlfcrlf
  while(*m+0 != '\r' && *m+1 != '\n' && *m+2 != '\r' && *m+3 != '\n') // when we have crlfcrlf, break, OR continue on all conditions where not crlfcrlf
    m++;
  //add everything
  char *p;
  p = m;
  while(*p+0 != '\r' && *p+1 != '\n' && *p+2 != '.' && *p+3 != '\r' && *p+4 != '\n')
    p++;
  //stop at . on a line
  //remember to look for crlf
  *(p+2) = '\0';
  return m;
}
