--------------------------------------------------------------------------------
-- intc_wrapper.vhd
--------------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;

-- synthesis translate_off
LIBRARY UNISIM;
USE UNISIM.VCOMPONENTS.ALL;
-- synthesis translate_on

LIBRARY opb_intc_v1_00_c;
USE opb_intc_v1_00_c.ALL;

ENTITY intc_wrapper IS
PORT (
	-- instance intc
	Intr : IN STD_LOGIC_VECTOR(0 DOWNTO 0);
	Irq : OUT STD_LOGIC;
	OPB_Clk : IN STD_LOGIC;
	OPB_Rst : IN STD_LOGIC;
	OPB_ABus : IN STD_LOGIC_VECTOR(0 TO 31);
	OPB_BE : IN STD_LOGIC_VECTOR(0 TO 3);
	OPB_RNW : IN STD_LOGIC;
	OPB_select : IN STD_LOGIC;
	OPB_seqAddr : IN STD_LOGIC;
	OPB_DBus : IN STD_LOGIC_VECTOR(0 TO 31);
	IntC_DBus : OUT STD_LOGIC_VECTOR(0 TO 31);
	IntC_errAck : OUT STD_LOGIC;
	IntC_retry : OUT STD_LOGIC;
	IntC_toutSup : OUT STD_LOGIC;
	IntC_xferAck : OUT STD_LOGIC);
END intc_wrapper;

ARCHITECTURE IMP OF intc_wrapper IS

--------------------------------------------------------------------------------
COMPONENT opb_intc IS
GENERIC (
	C_FAMILY : STRING := "spartan2e";
	C_Y : INTEGER := 0;
	C_X : INTEGER := 0;
	C_U_SET : STRING := "intc";
	C_OPB_AWIDTH : INTEGER := 32;
	C_OPB_DWIDTH : INTEGER := 32;
	C_BASEADDR : STD_LOGIC_VECTOR := X"ffff0000";
	C_HIGHADDR : STD_LOGIC_VECTOR := X"ffff00ff";
	C_NUM_INTR_INPUTS : INTEGER := 1;
	C_KIND_OF_INTR : STD_LOGIC_VECTOR := "00000000000000000000000000000001";
	C_KIND_OF_EDGE : STD_LOGIC_VECTOR := "00000000000000000000000000000001";
	C_KIND_OF_LVL : STD_LOGIC_VECTOR := "00000000000000000000000000000000";
	C_HAS_IPR : INTEGER := 1;
	C_HAS_SIE : INTEGER := 1;
	C_HAS_CIE : INTEGER := 1;
	C_HAS_IVR : INTEGER := 1;
	C_IRQ_IS_LEVEL : INTEGER := 1;
	C_IRQ_ACTIVE : STD_LOGIC := '1');
PORT (
	Intr : IN STD_LOGIC_VECTOR(C_NUM_INTR_INPUTS-1 DOWNTO 0);
	Irq : OUT STD_LOGIC;
	OPB_Clk : IN STD_LOGIC;
	OPB_Rst : IN STD_LOGIC;
	OPB_ABus : IN STD_LOGIC_VECTOR(0 TO 31);
	OPB_BE : IN STD_LOGIC_VECTOR(0 TO 3);
	OPB_RNW : IN STD_LOGIC;
	OPB_select : IN STD_LOGIC;
	OPB_seqAddr : IN STD_LOGIC;
	OPB_DBus : IN STD_LOGIC_VECTOR(0 TO 31);
	IntC_DBus : OUT STD_LOGIC_VECTOR(0 TO 31);
	IntC_errAck : OUT STD_LOGIC;
	IntC_retry : OUT STD_LOGIC;
	IntC_toutSup : OUT STD_LOGIC;
	IntC_xferAck : OUT STD_LOGIC);
END COMPONENT;

--------------------------------------------------------------------------------
-- internal signals
--------------------------------------------------------------------------------

BEGIN

--------------------------------------------------------------------------------
-- Power assignments
--------------------------------------------------------------------------------
-- Constant assignments
--------------------------------------------------------------------------------
-- Top-level port assignments
--------------------------------------------------------------------------------
-- Lower-level assignments

--------------------------------------------------------------------------------
opb_intc_0_i : opb_intc
GENERIC MAP (
	C_FAMILY => "spartan2e",
	C_Y => 0,
	C_X => 0,
	C_U_SET => "intc",
	C_OPB_AWIDTH => 32,
	C_OPB_DWIDTH => 32,
	C_BASEADDR => X"ffff0000",
	C_HIGHADDR => X"ffff00ff",
	C_NUM_INTR_INPUTS => 1,
	C_KIND_OF_INTR => "00000000000000000000000000000001",
	C_KIND_OF_EDGE => "00000000000000000000000000000001",
	C_KIND_OF_LVL => "00000000000000000000000000000000",
	C_HAS_IPR => 1,
	C_HAS_SIE => 1,
	C_HAS_CIE => 1,
	C_HAS_IVR => 1,
	C_IRQ_IS_LEVEL => 1,
	C_IRQ_ACTIVE => '1')
PORT MAP (
	Intr => Intr,
	Irq => Irq,
	OPB_Clk => OPB_Clk,
	OPB_Rst => OPB_Rst,
	OPB_ABus => OPB_ABus,
	OPB_BE => OPB_BE,
	OPB_RNW => OPB_RNW,
	OPB_select => OPB_select,
	OPB_seqAddr => OPB_seqAddr,
	OPB_DBus => OPB_DBus,
	IntC_DBus => IntC_DBus,
	IntC_errAck => IntC_errAck,
	IntC_retry => IntC_retry,
	IntC_toutSup => IntC_toutSup,
	IntC_xferAck => IntC_xferAck);

END ARCHITECTURE IMP;
